/* 
 * contr_bright_pgm.h
 * version 1.0
 * author Felix Burkhardt
 * last change:  Wed Sep  2 18:34:26 GMT 1998 
 *
 * Routinen fue Kontrast- und Brightness-Veraenderungen.
 * fuer Greymaps
 *
 * Die Routinen nehem einen Pointer auf Beschreibungstukturen
 * fuer die Anderungen
 * Jede Struktur besteht aus Reihenangabe und Veraenderungsfaktor
 * Die Strukturen MUESSEN nach aufsteigenden Reihen sortiert sein
 * Der Faktor ist um 0.5 skaliert (zwischen 0 and 1).
 *
 * Um den Kontrast zu veraendern wird der Mittelwert des Kanals
 * berechnet und als Kontrastgrenze verwendet.
 */


#ifndef _CONTRAST_BRIGHTNESS_H_
#define _CONTRAST_BRIGHTNESS_H_

#include "pixdef.h"
#include "pixutil.h"

typedef struct changeDescriptor *changeDescriptorP;

struct changeDescriptor {
  int row;            /* which row to change                       */
  double val;         /* which factor to change                    */
};

pixval *changeContrast_PGM(
	pixval *pix_array_in, 		/* inputPGM                */
	int width, int height,
	int ChangeDescrNum,      /* number of change-descriptors   */
	changeDescriptorP cDPointer); /* change-descriptors         */

pixval *changeBrightness_PGM(
	pixval *pix_array_in, 		/* inputPGM                */
	int width, int height,
	int ChangeDescrNum,      /* number of change-descriptors   */
	changeDescriptorP cDPointer); /* change-descriptors         */

#endif /*_CONTRAST_BRIGHTNESS_H_*/





