/*
** pixdef.h 
** globale defines und typedefs zur Pixelbearbeitung
** die Reihenfolge der channels ist rgba !!!
*/
#ifndef _PIXDEF_H_
#define _PIXDEF_H_

typedef unsigned char pixval;

#define CHANNELS 4
#define MAXVAL 255

#define CHANNEL_RED 1
#define CHANNEL_GREEN 2
#define CHANNEL_BLUE 4
#define CHANNEL_ALPHA 8

typedef struct {
  pixval r, g, b, a;
} pixel;

/* get coord. with 00 at upper left corner */
#define LOC(x, y, w, h) (h - 1 - y) * w + x 

#define PPM_GETR(p) ((p).r)
#define PPM_GETG(p) ((p).g)
#define PPM_GETB(p) ((p).b)
#define PPM_GETA(p) ((p).a)

#define PPM_PUTR(p,red) ((p).r = (red))
#define PPM_PUTG(p,grn) ((p).g = (grn))
#define PPM_PUTB(p,blu) ((p).b = (blu))
#define PPM_PUTA(p,alpha_val) ((p).alpha = (alpha_val))

#define LONG_GETR(p) (p & 0x000000ff)
#define LONG_GETG(p) (p & 0x0000ff00) >> 8
#define LONG_GETB(p) (p & 0x00ff0000) >> 16
#define LONG_GETA(p) (p & 0xff000000) >> 24

#define LONG_PUTR(p, r)  p |=  (long) r
#define LONG_PUTG(p, g)  p |=  (long) (g << 8)
#define LONG_PUTB(p, b)  p |=  (long) (b << 16) 
#define LONG_PUTA(p, a)  p |=  (long) (a << 24) 

#define LONG_PUTRGBA(p, r, g, b, a)  (p = (p|r) | (p|g) << 8 | (p|b) << 16 | (p|a) << 24)
#define LONG_PUTRGB(p, r, g, b)  (p = (p|r) | (p|g) << 8 | (p|b) << 16)

typedef int boolean;
#define TRUE 1
#define FALSE 0
 
#define SQRT_2 1.4142135623731
#define MAX(a, b) (((a) > (b)) ? (a) : (b))
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#define SGN(x) (((x) < 0) ? -1 : 1)
#define ABS(x) (((x) < 0) ? -(x) : (x))
#define SWAP(a, b) {a ^= b; b ^= a; a ^= b;}
#define SWAP_DOUBLE(a, b) {double tmp = b; b = a; a = tmp;}


#endif /*_PIXDEF_H_*/





