#include "pixutil.h"

pixval *getChannel(pixval *pixarray, int len, int flag) {
  int i;
  pixval *pixvec;

  pixvec = (pixval *) malloc(len * sizeof(pixval));

  for (i=0; i<len; i++) {
    switch(flag) {
    case 1:
      pixvec[i] = pixarray[CHANNELS * i + 0];
      break;
    case 2:
      pixvec[i] = pixarray[CHANNELS * i + 1];
      break;
    case 4:
      pixvec[i] = pixarray[CHANNELS * i + 2];
      break; 
    case 8:
      pixvec[i] = pixarray[CHANNELS * i + 3];
      break;
    default:
      return (pixval *) 0;
    }
  }
  return pixvec;
}

double getMeanChannel(pixval *pixchannel, int len) {
  long sum = 0;
  int i;

  for (i=0; i<len; i++)
    sum += pixchannel[i];
  if (len != 0)
    return (double) sum/len;
  else return -1;
}

double getMeanArray(long *pixarray, int len, int flag) {
  int i, sum=0;
  if (flag & CHANNEL_RED) {
    for (i=0; i<len; i++)
      sum += LONG_GETR(pixarray[i]);  
  }
  else if (flag & CHANNEL_GREEN) {
    for (i=0; i<len; i++)
      sum +=  LONG_GETG(pixarray[i]);
  }
  else if (flag & CHANNEL_BLUE) {
    for (i=0; i<len; i++)
      sum +=  LONG_GETB(pixarray[i]);
  }
  else { /* ALPHA */
    for (i=0; i<len; i++)
      sum +=   LONG_GETA(pixarray[i]);
  }
  return (double) sum/len;  
}

double getMeanPGM(long *pixarray, int len) {
  int i, sum=0;
  
  for (i=0; i<len; i++) {
    sum += LONG_GETR(pixarray[i]);  
    sum += LONG_GETG(pixarray[i]);
    sum += LONG_GETB(pixarray[i]);
    sum += LONG_GETA(pixarray[i]);
  }
  return (double) sum/len;  
}

